unit GeoYandex;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, IdCookieManager, IdIOHandler, IdIOHandlerSocket,
  IdSocks, IdIntercept, IdLogBase, IdLogFile, IdIOHandlerStream, pngimage, MapWinGIS_TLB,
  IniFiles, ExtCtrls, Buttons, DB, ADODB;

//  
type
 TParserXML=class
  public
   function ParsXML(XML,tag:WideString):WideString;
   function ParsXMLArr(XML,tag:WideString):TStrings;
end;

type
  TGeoCoderYandex = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    IdHTTP1: TIdHTTP;
    ComboBox1: TComboBox;
    Image1: TImage;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    SpeedButton1: TSpeedButton;
    IdLogFile1: TIdLogFile;
    ADOConnection1: TADOConnection;
    ADOQuery1: TADOQuery;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GeoCoderYandex: TGeoCoderYandex;
  Coord:TStrings;
  Ini:TIniFile;
  Coord2:TStringList;

implementation

uses Unit1, Settings;

{$R *.dfm}

function ClearDir( Dir: string ): boolean;
var
 isFound: boolean;
 sRec: TSearchRec;
begin
 Result := false;
 ChDir( Dir );
 if IOResult <> 0 then
  begin
   //ShowMessage( '    : ' + Dir );
   Exit;
  end;
  if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';
  isFound := FindFirst( Dir + '*.*', faAnyFile, sRec ) = 0;
  while isFound do
   begin
    if ( sRec.Name <> '.' ) and ( sRec.Name <> '..' ) then
    if ( sRec.Attr and faDirectory ) = faDirectory then
     begin
      if not ClearDir( Dir + sRec.Name ) then
       Exit;
      if ( sRec.Name <> '.' ) and ( sRec.Name <> '..' ) then
      if ( Dir + sRec.Name ) <> Dir then
       begin
        ChDir( '..' );
        RmDir( Dir + sRec.Name );
       end;
     end
    else
     if not DeleteFile( Dir + sRec.Name ) then
      begin
       //ShowMessage( '   : ' + sRec.Name );
       Exit;
      end;
     isFound := FindNext( sRec ) = 0;
    end;
  FindClose( sRec );
  Result := IOResult = 0;
end;

function TParserXML.ParsXML(XML,tag: WideString): WideString;
begin
   Delete(XML,1,pos('<'+tag+'>',XML)+length('<'+tag+'>')-1);
   Delete(XML,pos('</'+tag+'>',XML),length(XML));
   Result:=XML;
end;

function TParserXML.ParsXMLArr(XML, tag: WideString): TStrings;
var
 ParsTag:TParserXML;
 i:integer;
begin
   try
    Result:=TStringList.Create;
    ParsTag:=TParserXML.Create;
    i:=1;
    while (i<=length(XML)) do
     begin
      if pos('<'+tag+'>',XML)<>0 then
       begin
        Result.Add(Utf8ToAnsi(ParsTag.ParsXML(XML,tag)));
        Delete(XML,1,pos('</'+tag+'>',XML));
        i:=0;
       end;
      inc(i);
     end;
    ParsTag.Free;
   finally
   end;
end;

procedure TGeoCoderYandex.Button1Click(Sender: TObject);
var
 html,l,query:WideString;
 ParsClass:TParserXML;
 i:integer;
begin
 try
  //     ,     
  if CheckBox1.Checked=False then
   begin
    //      
    if Trim(Edit1.Text)='' then
     begin
      Application.MessageBox(' ','',MB_OK+MB_ICONINFORMATION);
      exit;
     end;
    //   Setting.ini
    if Ini.ReadString('GeoYandex','Proxy','')='True' then
     begin
      IdHTTP1.ProxyParams.ProxyPort:=Ini.ReadInteger('GeoYandex','ProxyPort',0);
      IdHTTP1.ProxyParams.ProxyServer:=Ini.ReadString('GeoYandex','ProxyIP','');
      IdHTTP1.ProxyParams.ProxyUsername:=Ini.ReadString('GeoYandex','ProxyUsername','');
      IdHTTP1.ProxyParams.ProxyPassword:=Ini.ReadString('GeoYandex','ProxyPassword','');
     end;
    if Ini.ReadString('GeoYandex','Log','')='True' then
     begin
      IdHTTP1.Intercept:=IdLogFile1;
      IdLogFile1.Filename:=Ini.ReadString('GeoYandex','LogFile','');
      IdLogFile1.Active:=True;
     end;
    Coord:=TStrings.Create;
    query:=Edit1.Text;
    while (pos(' ',query)<>0) do
     begin
      Insert('%20',query,pos(' ',query));
      Delete(query,pos(' ',query),1);
     end;
    html:=IdHTTP1.Get('http://geocode-maps.yandex.ru/1.x/?geocode='+AnsiToUtf8(query));
    ParsClass:=TParserXML.Create;
    ComboBox1.Items:=ParsClass.ParsXMLArr(html,'text');
    Coord:=ParsClass.ParsXMLArr(html,'pos');
    ComboBox1.ItemIndex:=0;
    if ComboBox1.Items.Count<>0 then
     begin
      ComboBox1.Enabled:=True;
      Button2.Enabled:=True;
      Button3.Enabled:=True;
     end
    else
     Application.MessageBox('     ','',MB_OK+MB_ICONINFORMATION);
   end;
  //     
  if CheckBox1.Checked=True then
   begin
   //      
    if Trim(Edit1.Text)='' then
     begin
      Application.MessageBox(' ','',MB_OK+MB_ICONINFORMATION);
      exit;
     end;
    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('SELECT * FROM Yandex WHERE name LIKE ''%'+Edit1.Text+'%''');
    ADOQuery1.Active:=True;
    if ADOQuery1.RecordCount=0 then
     begin
      Application.MessageBox('     ','',MB_OK+MB_ICONINFORMATION);
      exit;
     end;
    Coord2:=TStringList.Create;
    ADOQuery1.First;
    for i:=0 to ADOQuery1.RecordCount-1 do
     begin
      ComboBox1.Items.Add(ADOQuery1.Fields.Fields[1].AsString);
      Coord2.Add('31.010895 52.431881');
      ADOQuery1.Next;
     end;
     ComboBox1.ItemIndex:=0;
     ComboBox1.Enabled:=True;
     Button2.Enabled:=True;
   end;
  except
   on e:Exception do
    begin
     FreeAndNil(Coord2);
    end;
  end;
end;

procedure TGeoCoderYandex.Button2Click(Sender: TObject);
var
 img:TStringStream;
 crd,zoom,pixel:String;
 png:TPNGObject;
 i:Image;
begin
 if CheckBox1.Checked=False then
  begin
   // PNG-,     
   png:=TPNGObject.Create;
   //  
   crd:=Coord.Strings[ComboBox1.ItemIndex];
   Insert(',',crd,pos(' ',crd));
   Delete(crd,pos(' ',crd),1);
   //  INI-     
   zoom:=Ini.ReadString('GeoYandex','ZoomSize2','');
   pixel:=Ini.ReadString('GeoYandex','PixelSize2','');
   //   
   img:=TStringStream.Create(IdHTTP1.Get('http://static-maps.yandex.ru/1.x/?ll='+crd+'&spn='+zoom+'&size='+pixel+'&l=map'));
   //  PNG  
   png.LoadFromStream(img);
   //  
   png.SaveToFile(ExtractFilePath(ParamStr(0))+'Yandex\'+crd+'.png');
   i:=CoImage.Create;
   i.Open(ExtractFilePath(ParamStr(0))+'Yandex\'+crd+'.png',PNG_FILE,False,nil);
   //    TMap
   Form1.Map1.AddLayer(i,True);
   //          ,   
   if Ini.ReadString('GeoYandex','SaveMap','')<>'True' then
    begin
     //   ,  ,      TMap
     ClearDir(ExtractFilePath(ParamStr(0))+'Yandex\');
    end;
   FreeAndNil(png);
   FreeAndNil(Coord);
   Close;
  end;
 if CheckBox1.Checked=True then
  begin
   try
    //  
    crd:=Coord2.Strings[ComboBox1.ItemIndex];
    Insert(',',crd,pos(' ',crd));
    Delete(crd,pos(' ',crd),1);
    i:=CoImage.Create;
    i.Open(ExtractFilePath(ParamStr(0))+'Yandex\'+crd+'.png',PNG_FILE,False,nil);
    //    TMap
    Form1.Map1.AddLayer(i,True);
    FreeAndNil(Coord);
    Close;
   except
    on e:Exception do
     Application.MessageBox('   ','',MB_OK+MB_ICONINFORMATION);
   end;
  end;
end;

procedure TGeoCoderYandex.FormShow(Sender: TObject);
begin
   try
    Ini:=TIniFile.Create(ExtractFilePath(ParamStr(0))+'Setting\Setting.ini');
    Edit1.Clear;
    ComboBox1.Clear;
    if CheckBox1.Checked=False then
     begin
      ComboBox1.Enabled:=False;
      Button2.Enabled:=False;
      Button3.Enabled:=False;
     end
    else
     begin
      ComboBox1.Enabled:=True;
      Button2.Enabled:=True;
      Button3.Enabled:=True;
     end;
    if CheckBox1.Checked=True then
     begin
      ComboBox1.Clear;
      ComboBox1.Enabled:=False;
      FreeAndNil(Coord2);
      Button2.Enabled:=False;
     end;
   except
    on e:Exception do
   end;
end;

procedure TGeoCoderYandex.Button4Click(Sender: TObject);
begin
   Setting.ShowModal;
   Setting.PageControl1.ActivePage:=Setting.TabSheet2;
end;

procedure TGeoCoderYandex.CheckBox1Click(Sender: TObject);
begin
 try
  if CheckBox1.Checked=True then
   begin
    if (Ini.ReadString('GeoYandex','LoginBD','')='') and (Ini.ReadString('GeoYandex','PasswordBD','')='') then
     begin
      ADOConnection1.LoginPrompt:=False;
      ADOConnection1.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Data Source='+Ini.ReadString('GeoYandex','PatchBD','')+';Persist Security Info=False';
      ADOConnection1.Connected:=True;
      if ADOConnection1.Connected=True then
       Application.MessageBox('  ','',MB_OK+MB_ICONINFORMATION);
     end
    else
     begin
      ADOConnection1.LoginPrompt:=False;
      ADOConnection1.ConnectionString:='Provider=Microsoft.Jet.OLEDB.4.0;Data Source='+Ini.ReadString('GeoYandex','PatchBD','')+';Password='+Ini.ReadString('GeoYandex','PasswordBD','')+';User ID='+Ini.ReadString('GeoYandex','LoginBD','')+';Persist Security Info=False';
      ADOConnection1.Connected:=True;
      if ADOConnection1.Connected=True then
       Application.MessageBox('  ','',MB_OK+MB_ICONINFORMATION);
     end;
   end
  else
   begin
    ADOConnection1.Connected:=False;
   end;
     except
      on e:Exception do
       Application.MessageBox('    ','',MB_OK+MB_ICONINFORMATION);
   end;
end;

procedure TGeoCoderYandex.SpeedButton1Click(Sender: TObject);
begin
   try
    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('CREATE TABLE Yandex (id counter, name char, coordinat char)');
    ADOQuery1.ExecSQL;
    Application.MessageBox('  ','',MB_OK+MB_ICONINFORMATION);
   except
    on e:Exception do
     Application.MessageBox('   ','',MB_OK+MB_ICONINFORMATION);
   end;
end;

procedure TGeoCoderYandex.Button3Click(Sender: TObject);
var
 i:integer;
begin
   try
    ADOQuery1.SQL.Clear;
    ADOQuery1.SQL.Add('SELECT * FROM Yandex');
    ADOQuery1.Active:=True;
    ADOQuery1.Insert;
    ADOQuery1.Fields.Fields[1].AsString:=ComboBox1.Items[ComboBox1.ItemIndex];
    ADOQuery1.FieldByName('coordinat').AsVariant:=Coord.Strings[ComboBox1.ItemIndex];
    ADOQuery1.Post;
    Application.MessageBox('    ','',MB_OK+MB_ICONINFORMATION);
   except
    on e:Exception do
     Application.MessageBox('   ','',MB_OK+MB_ICONINFORMATION);
   end;
end;

end.
