unit Settings;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Spin, StdCtrls, IniFiles, Buttons;

type
  TSetting = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Label3: TLabel;
    Edit2: TEdit;
    Label4: TLabel;
    Edit3: TEdit;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    CheckBox2: TCheckBox;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Label6: TLabel;
    ComboBox2: TComboBox;
    Label7: TLabel;
    CheckBox3: TCheckBox;
    Edit4: TEdit;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    Label8: TLabel;
    Edit5: TEdit;
    SpeedButton2: TSpeedButton;
    Label9: TLabel;
    Edit6: TEdit;
    Label10: TLabel;
    Edit7: TEdit;
    OpenDialog2: TOpenDialog;
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Setting: TSetting;
  Ini:TIniFile;

implementation

{$R *.dfm}

//   Ini
procedure TSetting.FormShow(Sender: TObject);
begin
   try
    Ini:=TIniFile.Create(ExtractFilePath(ParamStr(0))+'Setting\Setting.ini');
    if Ini.ReadString('GeoYandex','Proxy','')='True' then
     CheckBox1.Checked:=True
    else
     CheckBox1.Checked:=False;
    if Ini.ReadString('GeoYandex','SaveMap','')='True' then
     CheckBox2.Checked:=True
    else
     CheckBox2.Checked:=False;
    //  INI  -,   
    if Ini.ReadString('GeoYandex','Log','')='True' then
     begin
      CheckBox3.Checked:=True;
      Edit4.Text:=Ini.ReadString('GeoYandex','LogFile','');
     end
    else
     CheckBox3.Checked:=False;
    //  -,      
    if CheckBox3.Checked=True then
     begin
      Edit4.Enabled:=True;
      Label7.Enabled:=True;
      SpeedButton1.Enabled:=True;
     end;
    //       False,      
    if CheckBox1.Checked=True then
     begin
      Label1.Enabled:=True;
      Label2.Enabled:=True;
      Label3.Enabled:=True;
      Label4.Enabled:=True;
      Edit1.Enabled:=True;
      Edit2.Enabled:=True;
      Edit3.Enabled:=True;
      SpinEdit1.Enabled:=True;
     end;
    //   INI-    
    if Ini.ReadString('GeoYandex','Log','')='True' then
     CheckBox3.Checked:=True
    else
     CheckBox3.Checked:=False;
    //  INI-  Proxy
    Edit1.Text:=Ini.ReadString('GeoYandex','ProxyIP','');
    Edit2.Text:=Ini.ReadString('GeoYandex','ProxyUsername','');
    Edit3.Text:=Ini.ReadString('GeoYandex','ProxyPassword','');
    SpinEdit1.Value:=Ini.ReadInteger('GeoYandex','ProxyPort',0);
    //  INI-      
    ComboBox1.ItemIndex:=Ini.ReadInteger('GeoYandex','ZoomSize',0);
    ComboBox2.ItemIndex:=Ini.ReadInteger('GeoYandex','PixelSize',0);
    Edit5.Text:=Ini.ReadString('GeoYandex','PatchBD','');
    Edit6.Text:=Ini.ReadString('GeoYandex','LoginBD','');
    Edit7.Text:=Ini.ReadString('GeoYandex','PasswordBD','');
   except
    on e:Exception do
     //  INI-
     FreeAndNil(Ini);
   end;
end;

//     -,      CheckBox
procedure TSetting.CheckBox1Click(Sender: TObject);
begin
    if CheckBox1.Checked=True then
     begin
      Label1.Enabled:=True;
      Label2.Enabled:=True;
      Label3.Enabled:=True;
      Label4.Enabled:=True;
      Edit1.Enabled:=True;
      Edit2.Enabled:=True;
      Edit3.Enabled:=True;
      SpinEdit1.Enabled:=True;
     end;
    if CheckBox1.Checked=False then
     begin
      Label1.Enabled:=False;
      Label2.Enabled:=False;
      Label3.Enabled:=False;
      Label4.Enabled:=False;
      Edit1.Enabled:=False;
      Edit2.Enabled:=False;
      Edit3.Enabled:=False;
      SpinEdit1.Enabled:=False;
     end;
end;

//  
procedure TSetting.Button2Click(Sender: TObject);
begin
   Close;
end;

// ,     ini
procedure TSetting.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   FreeAndNil(Ini);
end;

//    Setting.ini
procedure TSetting.Button1Click(Sender: TObject);
begin
   //    ,      INI-
   if CheckBox1.Checked=True then
    begin
     Ini.WriteString('GeoYandex','ProxyIP',Edit1.Text);
     Ini.WriteString('GeoYandex','ProxyUsername',Edit2.Text);
     Ini.WriteString('GeoYandex','ProxyPassword',Edit3.Text);
     Ini.WriteInteger('GeoYandex','ProxyPort',SpinEdit1.Value);
     Ini.WriteString('GeoYandex','Proxy','True');
    end
   else
    Ini.WriteString('GeoYandex','Proxy','False');
   if CheckBox2.Checked=True then
    begin
     Ini.WriteString('GeoYandex','SaveMap','True');
     Button2.Enabled:=True;
     Label7.Enabled:=True;
     Edit4.Enabled:=True;
    end
   else
    Ini.WriteString('GeoYandex','SaveMap','False');
   //     
   Ini.WriteInteger('GeoYandex','ZoomSize',ComboBox1.ItemIndex);
   Ini.WriteInteger('GeoYandex','PixelSize',ComboBox2.ItemIndex);
   Ini.WriteString('GeoYandex','ZoomSize2',ComboBox1.Items[ComboBox1.ItemIndex]);
   Ini.WriteString('GeoYandex','PixelSize2',ComboBox2.Items[ComboBox2.ItemIndex]);
   if CheckBox3.Checked=True then
    begin
     Ini.WriteString('GeoYandex','Log','True');
     Ini.WriteString('GeoYandex','LogFile',Edit4.Text);
    end
   else
    Ini.WriteString('GeoYandex','Log','False');
   if CheckBox3.Checked=True then
    begin
     Ini.WriteString('GeoYandex','Log','True');
     Ini.WriteString('GeoYandex','LogFile',Edit4.Text);
    end
   else
    begin
     Ini.WriteString('GeoYandex','Log','False');
     Ini.WriteString('GeoYandex','LogFile',Edit4.Text);
    end;
   Ini.WriteString('GeoYandex','PatchBD',Edit5.Text);
   Ini.WriteString('GeoYandex','LoginBD',Edit6.Text);
   Ini.WriteString('GeoYandex','PasswordBD',Edit7.Text);
   Close;
end;

procedure TSetting.CheckBox3Click(Sender: TObject);
begin
   if CheckBox3.Checked=True then
    begin
     SpeedButton1.Enabled:=True;
     Label7.Enabled:=True;
     Edit4.Enabled:=True;
    end;
   if CheckBox3.Checked=False then
    begin
     SpeedButton1.Enabled:=False;
     Label7.Enabled:=False;
     Edit4.Enabled:=False;
    end;
end;

procedure TSetting.SpeedButton1Click(Sender: TObject);
begin
   if OpenDialog1.Execute then
    begin
     Edit4.Text:=OpenDialog1.FileName;
    end;
end;

procedure TSetting.SpeedButton2Click(Sender: TObject);
begin
   if OpenDialog2.Execute then
    Edit5.Text:=OpenDialog2.FileName;
end;

end.
